DCMTK - Bug #984

Problem in DCMTK 3.6.6 with double call of DcmPixelData::decode()
2021-04-26 12:29 - Jorg Riesmeier

Status: Closed Start date: 2021-04-26
Priority: Normal Due date:

Assignee: Marco Eichelberg % Done: 100%
Category: Library Estimated time: 3:00 hours
Target version: 3.6.7

Module: dcmdata, demimgle Compiler:

Operating System:

Description

With commit 0e8fae86ca, DCMTK issue #845 has been fixed but at the same time it is not possible any longer to "decode" the pixel
data of a DICOM image twice.

The following sample program demonstrates this issue. It was provided by Daniel Grieger <Daniel.Grieger/at/ith-icoserve/dot/com>
who also reported this bug:

#include <iostream>

#include <dcmtk/dcmdata/dcfilefo.h>
#include <dcmtk/dcmimgle/dcmimage.h>
#include <dcmtk/dcmjpeg/djencode.h>
#include <dcmtk/dcmjpeg/djdecode.h>

int main ()
{
DJEncoderRegistration::registerCodecs () ;
DJDecoderRegistration: :registerCodecs (EDC_lossyOnly, EUC_default, EPC_colorByPixel, false);

const std::shared_ptr<DcmFileFormat> dcmFileFormat = std::make_shared<DcmFileFormat> () ;
std::cout << std::string(dcmFileFormat->loadFile (OFFilename ("test.dcm")) .text ()) << std::endl;
const std::shared_ptr<DicomImage> dicomImagel = std::make_shared<DicomImage> (dcmFileFormat->ge

tDataset (), dcmFileFormat->getDataset () —->getCurrentXfer());

std::cout << std::string(DicomImage::getString(dicomImagel->getStatus())) << std::endl;

const std::shared_ptr<DicomImage> dicomImage2 = std::make_shared<DicomImage> (dcmFileFormat->ge
tDataset (), dcmFileFormat->getDataset () —>getCurrentXfer());

std::cout << std::string(DicomImage::getString(dicomImage2->getStatus())) << std::endl;

DJEncoderRegistration::cleanup();
DJDecoderRegistration::cleanup();

return 0;

The output with the current DCMTK 3.6.6 is the following:

Normal

Status OK

E: no pixel data found in DICOM dataset
Missing attribute

With DCMTK 3.6.5 (i.e. before the above mentioned commit) the output was:

Normal
Status OK
Status OK

More details can be found in his email from 2021-04-06.
http://support.dcmtk.org/redmine/issues/845

Related issues:
Related to DCMTK - Feature #997: Revise mechanism to compress/decompress pixe... New 2021-07-07

History

#1 - 2021-07-06 20:02 - Marco Eichelberg
- Status changed from New to Closed

- Assignee set to Marco Eichelberg

- % Done changed from 0 to 100

- Estimated time set to 3:00 h

- Module changed from dcmdata to dcmdata, dcmimgle

Closed by commit #d1a561752.

#2 - 2021-07-07 10:51 - Jorg Riesmeier

- Related to Feature #997: Revise mechanism to compress/decompress pixel data added
